# SoVRMLTouchSensor Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLTouchSensor.h>`

Inheritance diagram for SoVRMLTouchSensor:

List of all members.

## Detailed Description

The SoVRMLTouchSensor class tracks to pointer position and sends events based on user interaction.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      TouchSensor {
        exposedField SFBool  enabled TRUE
        eventOut     SFVec3f hitNormal_changed
        eventOut     SFVec3f hitPoint_changed
        eventOut     SFVec2f hitTexCoord_changed
        eventOut     SFBool  isActive
        eventOut     SFBool  isOver
        eventOut     SFTime  touchTime
      }

A TouchSensor node tracks the location and state of the pointing device and detects when the user points at geometry contained by the TouchSensor node's parent group. A TouchSensor node can be enabled or disabled by sending it an enabled event with a value of TRUE or FALSE. If the TouchSensor node is disabled, it does not track user input or send events.

The TouchSensor generates events when the pointing device points toward any geometry nodes that are descendants of the TouchSensor's parent group. See 4.6.7.5, Activating and manipulating sensors (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.7.5>), for more details on using the pointing device to activate the TouchSensor.

The isOver eventOut reflects the state of the pointing device with regard to whether it is pointing towards the TouchSensor node's geometry or not. When the pointing device changes state from a position such that its bearing does not intersect any of the TouchSensor node's geometry to one in which it does intersect geometry, an isOver TRUE event is generated. When the pointing device moves from a position such that its bearing intersects geometry to one in which it no longer intersects the geometry, or some other geometry is obstructing the TouchSensor node's geometry, an isOver FALSE event is generated. These events are generated only when the pointing device has moved and changed `over' state. Events are not generated if the geometry itself is animating and moving underneath the pointing device.

As the user moves the bearing over the TouchSensor node's geometry, the point of intersection (if any) between the bearing and the geometry is determined. Each movement of the pointing device, while isOver is TRUE, generates hitPoint_changed, hitNormal_changed and hitTexCoord_changed events. hitPoint_changed events contain the 3D point on the surface of the underlying geometry, given in the TouchSensor node's coordinate system. hitNormal_changed events contain the surface normal vector at the hitPoint. hitTexCoord_changed events contain the texture coordinates of that surface at the hitPoint. The values of hitTexCoord_changed and hitNormal_changed events are computed as appropriate for the associated shape.

If isOver is TRUE, the user may activate the pointing device to cause the TouchSensor node to generate isActive events (e.g., by pressing the primary mouse button). When the TouchSensor node generates an isActive TRUE event, it grabs all further motion events from the pointing device until it is released and generates an isActive FALSE event (other pointing-device sensors will not generate events during this time). Motion of the pointing device while isActive is TRUE is termed a "drag." If a 2D pointing device is in use, isActive events reflect the state of the primary button associated with the device (i.e., isActive is TRUE when the primary button is pressed and FALSE when it is released). If a 3D pointing device is in use, isActive events will typically reflect whether the pointing device is within (or in contact with) the TouchSensor node's geometry.

The eventOut field touchTime is generated when all three of the following conditions are true:

- The pointing device was pointing towards the geometry when it was initially activated (isActive is TRUE).

- The pointing device is currently pointing towards the geometry (isOver is TRUE).

- The pointing device is deactivated (isActive FALSE event is also generated).

More information about this behaviour is described in 4.6.7.3, Pointing-device sensors (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.7.3>), 4.6.7.4, Drag sensors (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.7.4>), and 4.6.7.5, Activating and manipulating sensors (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.7.5>).

## Public Member Functions

| SoVRMLTouchSensor (void)
virtual SbBool | affectsState (void) const
virtual void | handleEvent (SoHandleEventAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFBool | enabled
SoSFVec3f | hitNormal_changed
SoSFVec3f | hitPoint_changed
SoSFVec2f | hitTexCoord_changed
SoSFBool | isActive
SoSFBool | isOver
SoSFTime | touchTime

## Protected Member Functions

virtual | ~SoVRMLTouchSensor ()
virtual void | notify (SoNotList *list)

## Constructor & Destructor Documentation

SoVRMLTouchSensor::SoVRMLTouchSensor | ( | void |  | ) |

| Constructor.

SoVRMLTouchSensor::~SoVRMLTouchSensor | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLTouchSensor::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

SbBool SoVRMLTouchSensor::affectsState | ( | void |  | ) | const`[virtual]`

Returns `TRUE` if the node could have any effect on the state during traversal.

If it returns `FALSE`, no data in the traversal-state will change from the pre-traversal state to the post-traversal state. The SoSeparator node will for instance return `FALSE`, as it pushes and pops the state before and after traversal of its children. All SoShape nodes will also return `FALSE`, as just pushing out geometry data to the rendering engine won't affect the actual rendering state.

The default method returns `TRUE`, on a "better safe than sorry" philosophy.

Reimplemented from SoNode.

void SoVRMLTouchSensor::handleEvent | ( | SoHandleEventAction * | action | ) | `[virtual]`

| Action method for SoHandleEventAction. Inspects the event data from action, and processes it if it is something which this node should react to. Nodes influencing relevant state variables for how event handling is done also overrides this method. Reimplemented from SoNode.

void SoVRMLTouchSensor::notify | ( | SoNotList * | list | ) | `[protected, virtual]`

| Notifies all auditors for this instance when changes are made. Reimplemented from SoNode.

## Member Data Documentation

SoSFBool SoVRMLTouchSensor::enabled

| TRUE is enabled. Default value is TRUE.

SoSFVec3f SoVRMLTouchSensor::hitNormal_changed

| An eventOut that is sent when the pointer is over some child geometry. Contains the object space normal.

SoSFVec3f SoVRMLTouchSensor::hitPoint_changed

| An eventOut that is sent when the pointer is over some child geometry. Contains the object space point.

SoSFVec2f SoVRMLTouchSensor::hitTexCoord_changed

| An eventOut that is sent when the pointer is over some child geometry. Contains the object space texture coordinates.

SoSFBool SoVRMLTouchSensor::isActive

| An event out that is sent when the active state changes. The sensor goes active when the user clicks on some child, and is inactive again when the mouse button is release.

SoSFBool SoVRMLTouchSensor::isOver

| An event out that is sent when the pointer is moved onto or away from a child object.

SoSFTime SoVRMLTouchSensor::touchTime

| An event out that is generated when the sensor is active and is currently pointing on some child geometry.

The documentation for this class was generated from the following files:

- SoVRMLTouchSensor.h
- TouchSensor.cpp